//=======================================================================================
// ____          ____    __    ______     __________   __      __       __        __
// \    \       |    |  |  |  |   _   \  |___    ___| |  |    |  |     /  \      |  |
//  \    \      |    |  |  |  |  |_)   |     |  |     |  |    |  |    /    \     |  |
//   \    \     |    |  |  |  |   _   /      |  |     |  |    |  |   /  /\  \    |  |
//    \    \    |    |  |  |  |  | \  \      |  |     |   \__/   |  /  ____  \   |  |____
//     \    \   |    |  |__|  |__|  \__\     |__|      \________/  /__/    \__\  |_______|
//      \    \  |    |   ________________________________________________________________
//       \    \ |    |  |  ______________________________________________________________|
//        \    \|    |  |  |         __          __     __     __     ______      _______
//         \         |  |  |_____   |  |        |  |   |  |   |  |   |   _  \    /  _____)
//          \        |  |   _____|  |  |        |  |   |  |   |  |   |  | \  \   \_______
//           \       |  |  |        |  |_____   |   \_/   |   |  |   |  |_/  /    _____  |
//            \ _____|  |__|        |________|   \_______/    |__|   |______/    (_______/
//
//  This file is part of VirtualFluids. VirtualFluids is free software: you can
//  redistribute it and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either version 3 of
//  the License, or (at your option) any later version.
//
//  VirtualFluids is distributed in the hope that it will be useful, but WITHOUT
//  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//
//  SPDX-License-Identifier: GPL-3.0-or-later
//  SPDX-FileCopyrightText: Copyright © VirtualFluids Project contributors, see AUTHORS.md in root folder
//
//! \addtogroup gpu_PostProcessor PostProcessor
//! \ingroup gpu_core core
//! \{
//! \author Martin Schoenherr
//======================================================================================
#ifndef Calc2ndMoments_H
#define Calc2ndMoments_H

class Parameter;
class CudaMemoryManager;

//2nd
void alloc2ndMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);
void init2ndMoments(Parameter* para);
void calc2ndMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);

//3rd
void alloc3rdMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);
void init3rdMoments(Parameter* para);
void calc3rdMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);

//higher order
void allocHigherOrderMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);
void initHigherOrderMoments(Parameter* para);
void calcHigherOrderMoments(Parameter* para, CudaMemoryManager* cudaMemoryManager);

#endif

//! \}
